//
//  function.c
//  es_6-Liste
//
//  Created by Pumo on 26/12/12.
//  Copyright (c) 2012 Pumo. All rights reserved.
//

#include <stdio.h>
#include <stdlib.h>
#include "function.h"
#define SEPARATORE ';'


void printGames(list games){
    if (!empty(games)){
        printf("Code: %d Title: %s Type: %c \nCopies available: %d Vote's average: %.2f\n\n", head(games).code, head(games).title, head(games).type, head(games).copiesAvailable, head(games).voteAverage);
        printGames(tail(games));
    }
}

void readList(char buffer[], FILE *f);

Boolean loadFromFile(char *fileName, list *games){
    FILE *videog;
    Element *arrayVideogiochi;
    int dimLogica;
    int code, copies;
    float vote;
    char type;
    char title[31];
    int i;
    char f;
    
    *games = emptyList();
    
    videog = fopen(fileName, "r");
    if (videog == NULL) { printf("Error opening file"); return FALSE; }
    
    dimLogica = 0;
    while (!feof(videog)){
        fscanf(videog, "%d", &code);
        readList(title, videog);
        fscanf(videog, " %c%d%f", &type, &copies, &vote);
        
        f = fgetc(videog);
        while (f!= 10 && f!=EOF)
            f = fgetc(videog);
        
        dimLogica++;
    }
    
    arrayVideogiochi = (Element*) malloc(sizeof(Element) * dimLogica);
    rewind(videog);
    
    i = 0;
    while (!feof(videog)){
        fscanf(videog, "%d", &arrayVideogiochi[i].code);
        readList(arrayVideogiochi[i].title, videog);
        fscanf(videog, " %c%d%f", &arrayVideogiochi[i].type, &arrayVideogiochi[i].copiesAvailable, &arrayVideogiochi[i].voteAverage);
        
        f = fgetc(videog);
        while (f!= 10 && f!=EOF)
            f = fgetc(videog);
        
        i++;
    }
        
    rewind(videog);
    fclose(videog);
    
    for (i=0; i<dimLogica; i++)
        *games = cons(arrayVideogiochi[i], *games);
    
    free(arrayVideogiochi);

    return TRUE;
}

void readList(char buffer[], FILE *f)
{
	int i = 0;
	char ch = fgetc(f);
	while (ch != SEPARATORE && ch != 10 && ch != EOF)
	{
		buffer[i] = ch;
		i++;
		ch = fgetc(f);
	}
	buffer[i] = '\0';
}

void isPresente(int code, list games);

Boolean updateAvailability(char *fileName, list games){
    FILE *vendita;
    int code;
    
    vendita = fopen(fileName, "r");
    if (vendita == NULL) { printf("Error opening file"); return FALSE; }
    
    while (fscanf(vendita, "%d", &code) == 1){
        isPresente(code, games);
    }
    
    fclose(vendita);
    return TRUE;
}


void isPresente(int code, list games){
    while (games != NULL){
        if (code == games->value.code){
            games->value.copiesAvailable -= 1;
        }
        games = games->next;
    }
}

list gamesForKids(list games, float threshold){
    list l2;
    
    l2 = emptyList();
    
    while (!empty(games)){
        if (head(games).copiesAvailable > 0){
            if (head(games).type == 'A')
                l2 = cons(head(games), l2);
            else if (head(games).type == 'P'){}
            else if (head(games).type == 'O' || head(games).type == 'R'){
                if (head(games).voteAverage > threshold)
                    l2 = cons(head(games), l2);
            }
        }
        
        games = tail(games);
    }
    
    return l2;
}

Boolean saveOrdersToFile(char *fileName, list games, int qty){
    FILE *ordini;
    
    ordini = fopen(fileName, "w");
    if (ordini == NULL) { printf("Error opening file"); return FALSE; }
    
    while (!empty(games)){
        if (qty <= head(games).copiesAvailable){}
        else {
            fprintf(ordini, "%d %s %d\n", head(games).code, head(games).title, (qty - head(games).copiesAvailable));
        }
        games = tail(games);
    }
    
    fclose(ordini);
    return TRUE;
}
































