#include <stdio.h>
#include <stdlib.h>
#include "list.h"

// PRIMITIVE

// Restituisce la lista vuota
list emptyList(void) { 
	return NULL; 
} 

// Restituisce vero se la lista data  vuota, falso altrimenti
Boolean empty(list l) {
	if (l==NULL) return TRUE; 
	else return FALSE; 
}

// Restituisce primo elemento della lista data
Element head(list l) {
	if (empty(l)) abort();
	else return  l->value; 
}

// Restituisce la coda della lista data
list tail(list l) {
	if (empty(l)) abort();
	else return l->next; 
}

// Costruisce una nuova lista, aggiungendo lelemento fornito in testa alla lista data
list cons(Element e, list l) { 
	list t;
	t = (list) malloc(sizeof(node));
	t->value=e; 
	t->next=l; 
	return t; 
}

// NON PRIMITIVE

#if 0
// Stampa lista
void showList(list l) { 
	printf("[");
	while (!empty(l)) { 
		printf("%d", head(l));
		l = tail(l);
		if (!empty(l)) printf(", "); 
	} 
	printf("]\n");
}
#endif

// Restituisce vero o falso a seconda se lelemento dato  presente nella lista data
#if 0
// Versione iterativa
Boolean member(Element el, list l) {
	while (!empty(l)) {
		if (el == head(l)) return TRUE; 
		else l = tail(l);
	} 
	return FALSE;
}
#endif

#if 0
// Versione ricorsiva
Boolean member(Element el, list l) {
	if (empty(l)) return FALSE;
	else if (el == head(l)) return TRUE;
	else return member(el, tail(l));
}
#endif

// Calcola il numero di elementi della lista data
#if 0
// Versione iterativa 
int length(list l) {
	int n = 0;
	while (!empty(l)) {
		n++; 
		l = tail(l); 
	} 
	return n;
}
#endif

#if 0
// Versione ricorsiva
int length(list l) {
	if (empty(l)) return 0;
	else return 1 + length(tail(l));
}
#endif

#if 1
// Restituisce una lista che  conca- tenamento delle due liste date
list append(list l1, list l2) { 
	if (empty(l1)) return l2;
	else return cons(head(l1), append(tail(l1),l2));
}
#endif

#if 1
// Restituisce una lista che  linverso della lista data
list reverse(list l) {
	if (empty(l)) return emptyList(); 
	else return append(reverse(tail(l)), cons(head(l), emptyList()));
}
#endif

#if 0
//Restituisce una lista che  copia della lista data
list copy(list l) {
	if (empty(l)) return l;
	else return cons(head(l), copy(tail(l)));
}
#endif

#if 0
// restituisce una lista che differisce da quella data solo per lassenza dellelemento indicato
list delet(Element el, list l) {
	if (empty(l)) return emptyList();
	else if (el == head(l)) return tail(l);
	else return cons(head(l), delet(el, tail(l)));
}
#endif

// ORDINAMENTO
#if 0
// Insord
list insord(Element el, list l) {
	if (empty(l)) return cons(el, l);
	else if (el <= head(l)) return cons(el, l);
	else return cons(head(l), insord(el, tail(l)));
}

// Esempio di insord nel main..
/*
 l1Ord = emptyList(); // Temporanea/ordinata
 
 printf("\nLa lista ordinata e': \n\n");
 while (!empty(l1)) {
    l1Ord = insord(head(l1), l1Ord);
    l1 = tail(l1);
 }
 
 showList(l1Ord);
 */
#endif

#if 0
// Mergelist
list mergeList(list l1, list l2) {
	if (empty(l1)) return l2;
	else if (empty(l2)) return l1;
	else { 
		if (isLess(head(l1), head(l2)))
		return cons(head(l1),mergeList(tail(l1),l2));
		else if (isEqual(head(l1), head(l2))) return cons(head(l1),mergeList(tail(l1),tail(l2))); 
		else return cons(head(l2),mergeList(l1,tail(l2)));
	}
}

#endif

#if 0
// Costruire lista da input e ordinarla..
list inputordlist(int n) { 
	Element e; 
	
	if (n<0) abort();
	else if (n == 0) return emptyList();
	else { 
		scanf("%d", &e);
		return insord(e, inputordlist(n-1));
	}	
}
#endif

// DEALLOCAZIONE
void dealloc(list l){
    list temp;
    while (!empty(l)) {
        temp = l;
        l = tail(l);
        free(temp);
    }
}